<?php

/** Custom Post Types */
function products_post_type() {
    $labels = array(
        'name'                => 'Products',
        'singular_name'       => 'Product',
        'menu_name'           => 'Products',
        'parent_item_colon'   => 'Parent product',
        'all_items'           => 'All products',
        'view_item'           => 'See product',
        'add_new_item'        => 'Add product',
        'add_new'             => 'Add new',
        'edit_item'           => 'Edit product',
        'update_item'         => 'Update',
        'search_items'        => 'Search products',
        'not_found'           => 'Not found',
        'not_found_in_trash'  => 'Not found'
    );
    $args = array(
        'label' => 'product',
        'rewrite' => array(
            'slug' => 'products'
        ),
        'query_var'           => true,
        'description'         => 'Product',
        'labels'              => $labels,
        'supports'            => array( 'title', 'editor', 'thumbnail', 'comments' ),
        'taxonomies'          => array('post_tag', 'category'),
        'hierarchical'        => false,
        'public'              => true,
        'show_ui'             => true,
        'show_in_menu'        => true,
        'show_in_nav_menus'   => true,
        'show_in_admin_bar'   => true,
        'show_in_rest'        => true,
        'menu_position'       => 3,
        'menu_icon'           => 'dashicons-awards',
        'can_export'          => true,
        'has_archive'         => false,
        'exclude_from_search' => false,
        'publicly_queryable'  => true,
        'capability_type'     => 'post',
    );
    register_post_type( 'products', $args );
}
add_action( 'init', 'products_post_type', 0 );