<?php
/*
Plugin Name: Replace content
Description: Wtyczka daje możliwość zmiany treści w pełni zachowując starą treść.
Author: DKiT
Version: 1.1.2
*/


/** Include metaboxes */
require_once( dirname(__FILE__) . '/metaboxes.php');


/** Replace title */
function replace_default_title($title_default) {
    global $post;

    if ($post) {
        $new_title = get_post_meta($post->ID, 'dkit_new_title', true);
        $replace_content = get_post_meta($post->ID, 'dkit_accept_content_replacement', true);

        if ($replace_content && !empty($new_title)) return $new_title; else return $title_default;
    }
}

function set_custom_title() {
    add_filter( 'the_title', 'replace_default_title');
}
add_action( 'loop_start', 'set_custom_title' );


/** Replace content */
function replace_default_content($content_default) {
    global $post;

    if ($post) {
        $new_content = get_post_meta($post->ID, 'dkit_new_content', true);
        $replace_content = get_post_meta($post->ID, 'dkit_accept_content_replacement', true);

        if ($replace_content && !empty($new_content)) return $new_content; else return $content_default;
    }
}
add_filter( 'the_content', 'replace_default_content' );


/** Replace excerpt */
function replace_default_excerpt($excerpt_default) {
    global $post;

    if ($post) {
        $new_excerpt = get_post_meta($post->ID, 'dkit_new_excerpt', true);
        $replace_content = get_post_meta($post->ID, 'dkit_accept_content_replacement', true);

        if ($replace_content && !empty($new_excerpt)) return $new_excerpt; else return $excerpt_default;
    }
}
add_filter( 'the_excerpt', 'replace_default_excerpt' );
add_filter( 'get_the_excerpt', 'replace_default_excerpt' );


/** Stop removing empty span tag */
function override_mce_options($initArray) {
    $opts = '*[*]';
    $initArray['valid_elements'] = $opts;
    $initArray['extended_valid_elements'] = $opts;
    return $initArray;
}
add_filter('tiny_mce_before_init', 'override_mce_options');