<?php
/** Image thumbnail size */
add_image_size('top-proucts-widget-thumbnail', 120, 200, true);

/** Widget Top (3) produkty */
class DKiT_Top_3_produkty extends WP_Widget {

    function __construct() {

        parent::__construct(

            'dkit-top-proucts-widget',  // Base ID
            'DKiT: Top (3) produkty',  // Name
            array( 'description' =>  'Wyświetla Top produktów', 'dkit', )  // Description

        );

        add_action( 'widgets_init', function() {
            register_widget( 'DKiT_Top_3_produkty' );
        } );

        }

    public function widget( $args, $instance ) {

        echo $args['before_widget'];

        if ( ! empty( $instance['title'] ) || ! empty( $instance['title_2'] ) || ! empty( $instance['title_3'] ) ) {

            echo '<h3 class="top-proucts-widget-title widget-title">' . '<span class="top-proucts-widget-title-1">' . $instance['title'] . '</span>' . ' <span class="top-proucts-widget-title-2">' . $instance['title_2'] . '</span>' . ' <span class="top-proucts-widget-title-3">' . $instance['title_3'] . '</span></h3>';
            echo "<ul>";
        }
        
        $products_list = (rank_get_option('products_list'));
        $best          = rank_get_option('add_best_class');
        $widget_limit  = $instance['quantity'];
        if ($widget_limit > count($products_list)) : $widget_limit = count($products_list);
        endif;
        if ( is_array( $products_list ) ) :

            for ( $i = 0; $i < $widget_limit ; $i++ ) :

                $product = $products_list[$i];
                $arguments     = array(
                    'post_type' => 'products',
                    'p' => $product
                );
                $query = new WP_Query( $arguments );

                if ( $query->have_posts() ) : 

                    while ( $query->have_posts() ) : 

                        $query->the_post();
                        $count = $i + 1;
                        $product_classes = $count == 1 ? ( $best ? 'best_product' : '' ) : '';

                        ?>

                        <li>
                        <div class="<?=$product_classes?>">
                            <?php the_title( '<h2><a href="' . get_the_permalink() . '">' . $count . '. ', '</a></h2>' ); ?>
                            <a href="<?=get_the_permalink()?>"><?php the_post_thumbnail(); ?></a>

                            <?php

                            $readMore  = '<a href="' . get_the_permalink() . '">';
                            $readMore .= __('Read More', 'nanobrow_base');
                            $readMore .= '</a>';

                            if ( get_post_meta( $product, 'dkit_new_excerpt', true ) &&  get_post_meta( $product, 'dkit_accept_content_replacement', true )) :
                                
                                $output  = get_post_meta( $product, 'dkit_new_excerpt', true );
                                $output .= $readMore;
                                echo $output;

                            elseif ( get_post_meta( $product, 'review_main_page', true ) ) :

                                $output  = get_post_meta( $product, 'review_main_page', true );
                                $output .= $readMore;
                                echo $output;

                            else: 

                                the_excerpt();

                            endif;

                            ?>

                        </div>
                        </li>

                        <?php

                    endwhile;

                    wp_reset_postdata(); // reset the query
                    
                else :

                    echo "<h3>Brak wpisów</h3>";

                endif; 
                
            endfor;

            echo "</ul>";
            echo $args['after_widget'];
        endif;

    }

    public function form( $instance ) {
        $title      = ! empty( $instance['title'] ) ? $instance['title'] : '';
        $title_2    = ! empty( $instance['title_2'] ) ? $instance['title_2'] : '';
        $title_3    = ! empty( $instance['title_3'] ) ? $instance['title_3'] : '';
        $link_more  = ! empty( $instance['link_more'] ) ? $instance['link_more'] : 'Czytaj więcej';
        $quantity   = ! empty( $instance['quantity'] ) ? $instance['quantity'] : '3';
    ?>
        <p>
            <label for="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>"><?php echo 'Tytuł:'; ?></label>
            <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'title' ) ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>">
        </p>
        <p>
            <label for="<?php echo esc_attr( $this->get_field_id( 'title_2' ) ); ?>"><?php echo 'Tytuł 2:'; ?></label>
            <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'title_2' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'title_2' ) ); ?>" type="text" value="<?php echo esc_attr( $title_2 ); ?>">
        </p>
        <p>
            <label for="<?php echo esc_attr( $this->get_field_id( 'title_3' ) ); ?>"><?php echo 'Tytuł 3:'; ?></label>
            <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'title_3' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'title_3' ) ); ?>" type="text" value="<?php echo esc_attr( $title_3 ); ?>">
        </p>
        <p>
            <label for="<?php echo esc_attr( $this->get_field_id( 'link_more' ) ); ?>"><?php echo 'Przycisk "Czytaj więcej":'; ?></label>
            <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'link_more' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'link_more' ) ); ?>" type="text" value="<?php echo esc_attr( $link_more ); ?>">
        </p>
        <p>
            <label for="<?php echo esc_attr( $this->get_field_id( 'quantity' ) ); ?>"><?php echo 'Ilość postów:'; ?></label>
            <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'quantity' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'quantity' ) ); ?>" type="number" min="1" value="<?php echo esc_attr( $quantity ); ?>">
        </p>
    <?php
        $args = array(
            'public' => true,
            '_builtin' => false,
        );
        $custom_post_types = get_post_types( $args );
    ?>
    <?php }
    public function update( $new_instance, $old_instance ) {
            $instance = array();
            $instance['title'] = ( !empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
            $instance['title_2'] = ( !empty( $new_instance['title_2'] ) ) ? strip_tags( $new_instance['title_2'] ) : '';
            $instance['title_3'] = ( !empty( $new_instance['title_3'] ) ) ? strip_tags( $new_instance['title_3'] ) : '';
            $instance['link_more'] = ( !empty( $new_instance['link_more'] ) ) ? strip_tags( $new_instance['link_more'] ) : '';
            $instance['quantity'] = ( !empty( $new_instance['quantity'] ) ) ? strip_tags( $new_instance['quantity'] ) : '';
            return $instance;
        }
}
$dkit_Top_3_produkty = new DKiT_Top_3_produkty();