<?php
add_action( 'cmb2_admin_init', 'create_review' );
function create_review() {
$review = new_cmb2_box( array(
  'id'            => 'review_box',
  'title'         => 'Recenzja',
  'object_types'  => array( 'products', ), // Post type
  'context'       => 'normal',
  'priority'      => 'high',
  'show_names'    => true, // Show field names on the left
  'cmb_styles'    => true, // false to disable the CMB stylesheet
));
$review->add_field( array(
	'name'    => 'Zajawka',
	'desc'    => 'treść pokazywana na stronie głownej',
	'id'      => 'review_main_page',
	'type'    => 'wysiwyg',
	'options' => array(),
) );
$review->add_field( array(
  'name'          => 'Pozycja recenzji',
  'id'            => 'review_position',
  'desc'          => 'Wybierz pozycję wyświetlania recenzji',
  'type'          => 'select',
  'options_cb'    => 'display_review_position_options',
  'render_row_cb' => 'display_review_position_fields',
));
$review->add_field( array(
  'name' => 'Tytuł recenzji',
  'desc' => 'Wyświetlane nad recenzją',
  'id'   => 'review_title',
  'type' => 'text',
));
$review->add_field( array(
  'name' => 'Tytuł podsumowania',
  'desc' => 'Wyświetlane na końcu recenzji',
  'id'   => 'review_summary_title',
  'type' => 'text',
));
$rate_group = $review->add_field( array(
  'id'         => 'rate_group',
  'type'       => 'group',
  'repeatable' => true, // use false if you want non-repeatable group
  'options'    => array(
    'group_title'   => 'Kryterium {#}', // since version 1.1.4, {#} gets replaced by row number
    'add_button'    => 'Dodaj kolejne kryteriu',
    'remove_button' => 'Usuń kryterium',
    'sortable'      => false,
    'closed'        => true, // true to have the groups closed by default
  ),
));
$review->add_group_field($rate_group, array(
  'name'          => 'Kryterium',
  'desc'          => 'Wpisz tutaj kryterium oceny',
  'id'            => 'rate_label',
  'type'          => 'text',
  'repeatable'    => true,
  'render_row_cb' => 'display_rate_fields',
));
$review->add_group_field($rate_group, array(
  'name'          => 'Ocena',
  'desc'          => 'Wpisz tutaj ocenę',
  'id'            => 'rate_val',
  'type'          => 'text',
  'render_row_cb' => 'display_rate_fields',
  'attributes'    => array(
    'type' => rank_get_option('review_type') == 'word' ? 'text' : 'number',
  ),
));


}
function display_review_position_options() {
  return array(
    'none'   => 'Nie wyświetlaj',
    'before' => 'Przed treścią wpisu',
    'after'  => 'Po treści wpisu',
    'default' => 'Standartowe',
    'custom' => 'Własna',
  );
}

function display_rate_fields( $field_args, $field ) {
  $id          = $field->args( 'id' );
  $label       = $field->args( 'name' );
  $name        = $field->args( '_name' );
  $value       = $field->escaped_value();
  $description = $field->args( 'description' );
  $type        = $field->args( 'attributes', 'type') ? $field->args( 'attributes', 'type') : 'text';
  ?>
  <div style="display: inline-block; margin-right: 20px;">
    <label for="<?php echo $id; ?>"><?php echo $label; ?>
    <input id="<?php echo $id; ?>" type="<? echo $type ?>" name="<?php echo $name; ?>" value="<?php echo $value; ?>"/>
    </label><br>
    <em>(<?php echo $description; ?>)</em>
  </div>
<?php
}

function display_review_position_fields( $f_args, $f ) {
  $name    = $f_args['name'];
  $desc    = $f_args['desc'];
  $id      = $f_args['id'];
  $options = display_review_position_options();
  $value   = $f->escaped_value();
  $post_id = $f->object_id;
?>
<div class="cmb-row cmb-type-select cmb2-id-review-type" data-fieldtype="select">
<div class="cmb-th">
<label for="<?=$id?>"><?=$name?></label>
</div>
  <div class="cmb-td">
    <select class="cmb2_select" name="<?=$id?>" id="<?=$id?>" data-hash="1gnotga895ig">
      <?php foreach( $options as $k => $v ) : ?>
      <option value="<?=$k?>"<?=$k==$value ? ' selected="selected"' : ''?>><?=$v?></option>
      <?php endforeach; ?>
    </select>
    <p class="cmb2-metabox-description"><?=$desc?></p>
    <p class="review_shortcode"<?=$value != 'custom' ? 'style="display: none;"' : ''?>>
      <b>Wklej ten shortcode w dowolne miejsce w treści wpisu:</b><br>
      <input type="text" value='<?='[review id="'.$post_id.'"]'?>' disabled>
    </p>
    <script>
        jQuery(function ($) {
            $('#<?=$id?>').change(function(){
            if ( $(this).val() == 'custom' ) {
                $('.review_shortcode').fadeIn(200);
            } else {
                $('.review_shortcode').fadeOut(200);
            }
        });
    });
    </script>
  </div>
</div>
<?php
}

function check_rate_val( $type, $val ) {
  switch ($type) {
    case 'percent':
      $min = 1;
      $max = 100;
      $val_type = 'precent';
      break;
    case 'ten':
      $min = 1;
      $max = 10;
      $val_type = 'number_10';
      break;
    case 'hundred':
      $min = 1;
      $max = 100;
      $val_type = 'number_100';
      break;
    case 'stars':
      $min = 1;
      $max = 5;
      $val_type = 'stars';
      break;
    case 'word':
      $val_type = 'word';
      break;
  }
  if ($val_type != 'word'):
  $rate_val = $val < $min ? $min : $val;
  $rate_val = $rate_val > $max ? $max : $rate_val;
  return ['val' => $rate_val, 'type' => $val_type];

  endif;
}
function render_review( $id ) {
  $rating      = get_post_meta( $id, 'rate_group', true);
  $tytul       = get_post_meta( $id, 'review_title', true);
  $review_type = rank_get_option('review_type');
  $summary     = get_post_meta( $id, 'review_summary_title', true);
  $rate_sum    = 0;
  $output  = '<section class="';
  $output .= $tytul==null ? 'd-none">' : '">' . "\n";
  $output .= '<h3>' . $tytul . '</h3>' . "\n";
    if($rating){
      foreach ($rating as $rate) {
        $label     = $rate['rate_label'];
        $val       = check_rate_val( $review_type, $rate['rate_val'] );
        $val_type  = $val['type'];
        $val       = $val['val'];
        $rate_sum += $val;
        $val .= $val_type == 'precent' ? '%' : '';
        $val .= $val_type == 'number_10' ? '/10' : '';
        $val .= $val_type == 'number_100' ? '/100' : '';
        $val .= $val_type == 'stars' ? stars_review($val) : '';
        $output .= "<p>$label: $val</p\n>";
      }
    }
    $review_average  = round(($rate_sum / count($rating)), 1);
    $review_average .= $review_type == 'percent' ? '%' : '';
    $review_average .= $review_type == 'ten' ? '/10' : '';
    $review_average .= $review_type == 'hundred' ? '/100' : '';
    $review_average .= $review_type == 'stars' ? stars_review($review_average) : '';
    $output .= $summary ? "<p>$summary: $review_average</p>\n</section>" : "</section>";
  return $output;
}

function stars_review($val) {
  $star = get_template_directory_uri().'/img/stars-gray.png';
  $star_full = get_template_directory_uri().'/img/stars-gold.png';
  $output   = '<div class="stars">';
  $output  .= '<img src="'.$star.'" class="star">';
  $output  .= '<div class="stars-rating" style="width: calc(100%*'.$val.'/5)">';
  $output  .= '<img src="'.$star_full.'" class="star">';
  $output  .= '</div></div>';
  return $output;
}

function word_review($id) {
  $rating   = get_post_meta( $id, 'rate_group', true);
  $tytul    = get_post_meta( $id, 'review_title', true);
  if($rating){
    foreach ($rating as $rate) {
      $label    = $rate['rate_label'];
      $val      = $rate['rate_val'];
      $output   = $label;
      $output  .= ' ';
      $output  .= $val;
    }
  }
  return $output;
}


function create_review_shortcode($atts) {
  $atts = shortcode_atts(
    array(
      'id' => '',
    ),
  $atts,
    'review'
  );
  $id = $atts['id'];
  if($review_type = rank_get_option('review_type') == 'word')
  {
  return get_post_meta( $id, 'review_position', true) == 'custom' ? word_review($id) : null;
  }
  else{
    return get_post_meta( $id, 'review_position', true) == 'custom' ? render_review($id) : null;
  }
  
}
  add_shortcode( 'review', 'create_review_shortcode' );


?>
