<?php
add_action( 'cmb2_admin_init', 'yourprefix_register_theme_options_metabox' );
function yourprefix_register_theme_options_metabox() {
	/**
	 * Registers options page menu item and form.
	 */
	$cmb_options = new_cmb2_box( array(
		'id'           => 'rank_id',
		'title'        => esc_html__( 'Theme Options', 'cmb2' ),
		'object_types' => array( 'options-page' ),
		/*
		 * The following parameters are specific to the options-page box
		 * Several of these parameters are passed along to add_menu_page()/add_submenu_page().
		 */
		'option_key'      => 'rank', // The option key and admin menu page slug.
		//'icon_url'        => 'dashicons-palmtree', // Menu icon. Only applicable if 'parent_slug' is left empty.
		//'menu_title'      => esc_html__( 'Ustawienia motywu', 'cmb2' ), // Falls back to 'title' (above).
		'parent_slug'     => 'themes.php', // Make options page a submenu item of the themes menu.
		//'capability'      => 'manage_options', // Cap required to view options-page.
		//'position'        => 1, // Menu position. Only applicable if 'parent_slug' is left empty.
        //'admin_menu_hook' => 'network_admin_menu', // 'network_admin_menu' to add network-level options page.
		//'display_cb'      => false, // Override the options-page form output (CMB2_Hookup::options_page_output()).
		//'save_button'     => esc_html__( 'Zapisz ustawienia', 'cmb2' ), // The text for the options-page save button. Defaults to 'Save'.
		//'disable_settings_errors' => true, // On settings pages (not options-general.php sub-pages), allows disabling.
		// 'message_cb'      => 'yourprefix_options_page_message_callback',
		'vertical_tabs' => true,
		'tabs' => array(
			array(
				'id'	  =>  'tabs-1',
				'title'   =>  'Ustawienia Rankingu',
				'fields'  =>  array(
					'products_list',
					'review_type',
					'add_best_class',
				),
			),
			array(
				'id'	  =>  'tabs-2',
				'title'   =>  'Ustawienia Strony',
				'fields'  =>  array(
					'excerpt_length_custom',
					'pagination',
					'recommended_articles',
				),
            ),
		)
		) );
	$cmb_options->add_field( array(
		'name' => 'Długość zajawki',
		'desc' => 'Liczba słów wyświetlanych na stronie, gdy pole zajawki jest puste. (Tylko wartości liczbowe)',
		'id'   => 'excerpt_length_custom',
		'type' => 'text',
		'attributes' => array(
			'type' => 'number',
			'min'  => '0',
		),
    ) );
	$cmb_options->add_field( array(
		'name'     			=> 'Sortowanie produktów',
		'id'       			=> 'products_list',
		'type' 	   			=> 'select',
		'repeatable' 		=> true,
		'show_option_none'  => ' ',
		'default'          	=> 'custom',
		'options_cb' 		=> 'ranking_select_options',
	) );
	$cmb_options->add_field( array(
		'name'    => 'Paginacja strony',
		'id'      => 'pagination',
		'type'    => 'radio_inline',
		'options' => array(
			'naviganiton' => 'Poprzednie / Następne',
			'pagination'   => 'Numeryczna (1 2 3 ... 5)',
		),
		'default' => 'naviganiton',
	) );
	$cmb_options->add_field( array(
		'name' => 'Polecane wpisy', 'theme-domain' ,
		'desc' => 'Ilość wpisów, która będzię wyświetlana na końcu artykułu. Wpisz 0 - żeby nie wyświetlać', 'theme-domain',
		'id'   => 'recommended_articles',
		'type' => 'text',
		'attributes' => array(
			'type' => 'number',
			'min'  => '0',
		),
	) );
	$cmb_options->add_field( array(
		'name'        => 'Typ oceny',
		'id'          => 'review_type',
		'desc'        => 'Wybierz w jaki sposób będzie pokazywana ocena produktu',
		'type'        => 'select',
		'default'     => 'hundred_format',
		'options_cb'  => 'review_type_options',
	  ));
	  $cmb_options->add_field( array(
		'name'    => 'Wyróżnienie głównego produktu',
		'desc'    => 'Wyróżnij produkt główny',
		'id'      => 'add_best_class',
		'type'    => 'checkbox',
	) );
}
function review_type_options() {
	return array(
	  'percent' 	=> '1-100%',
	  'ten'     	=> '1-10',
	  'hundred' 	=> '1-100',
	  'stars'   	=> '★★★★★',
	  'word'		=> 'słownie',
	);
  }
function ranking_select_options($group_field) {
	$args = array(
		'numberposts' => -1,
		'post_type'   => 'products',
	);
	$posts = get_posts( $args );
    if ( $posts ) {
        foreach ( $posts as $post ) {
		  $post_options[ $post->ID ] = $post->post_title;
		}
    } else {
		$post_options['none'] = 'Brak Wpisów';
	}
	return $post_options;
}
if ( ! function_exists( 'rank_get_option' ) ) {
	function rank_get_option( $key, $default = null ) {
		if ( function_exists( 'cmb2_get_option' ) ) {
			return cmb2_get_option( 'rank', $key, $default );
		}
		$option = get_option( 'rank', $default );
		$val = $default;
		if ( 'all' == $key ) {
			$val = $option;
		} elseif ( is_array( $option ) && array_key_exists( $key, $option ) && false !== $option[ $key ] ) {
			$val = $option[ $key ];
		}
		var_dump($val);
		return $val;
	}
}

?>