<?php
/**
 * Template part for displaying posts
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/
 *
 * @package Nanobrow_base
 */

?>

<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
	<header class="entry-header">
		<?php
		if ( is_singular() ) :
			the_title( '<h1 class="entry-title">', '</h1>' );
		else :
			the_title( '<h2 class="entry-title"><a href="' . esc_url( get_permalink() ) . '" rel="bookmark">', '</a></h2>' );
		endif;

		if ( 'post' === get_post_type() ) :
			?>
			<div class="entry-meta">
			</div>
		<?php endif; ?>
	</header>

	<?php
	nanobrow_base_post_thumbnail();
	?>

	<div class="entry-content">
		<?php
	if($review_type = rank_get_option('review_type') == 'word') {
			echo get_post_meta( $id, 'review_position', true) == 'before' ? word_review(get_the_ID()) : null;
			the_content();
			echo get_post_meta( $id, 'review_position', true) == 'after' ? word_review(get_the_ID()) : null;
			wp_link_pages( array(
				'before' => '<div class="page-links">' . esc_html__( 'Pages:', 'nanobrow_base' ),
				'after'  => '</div>',
			) );
		}
		else {
			echo get_post_meta( $id, 'review_position', true) == 'before' ? render_review(get_the_ID()) : null;
			the_content();
			echo get_post_meta( $id, 'review_position', true) == 'after' ? render_review(get_the_ID()) : null;
			wp_link_pages( array(
				'before' => '<div class="page-links">' . esc_html__( 'Pages:', 'nanobrow_base' ),
				'after'  => '</div>',
			) );
		}
		?>
	</div>
</article>
